Smooth <-
function (startX, endX, Avg=1, lum=4, sizePts=2, binPts=15,k=6,yLab,Rverbose=0, myData,fileName,startData,fileNum,export=F,fileoutSmooth="") {
#  starting column, ending column, Average or Individual, #minutes between points, # points to bin, # minutes/unit (usually day)
# does a moving average across k elements
  #require(delftfews)
  #library(stats)
modulo <-1440

  CatBins<-CatBin(startX, endX, Avg, lum, sizePts, binPts,modulo, startData=1,myData)
  # returns newMinPerBin,dataPts,binsPerDay,animals, startData, endData, DataList,plotCnt
  
  DataList<-CatBins$DataList
  TimeBins<-CatBins$TimeBins
  op<-par()
  thisTime <- format(Sys.time(), "%b %d, %Y - %H:%M:%S");
  
nameVector = paste(" ",names(myData),sep=" ")

  par(new=FALSE)
for (cnt in 1:CatBins$plotCnt) {      #  1 plot per animal, for all animals 
  #par(mfrow=c(2,1))    #,omi = c(0,0,1,0)) 
  par(oma=c(2,0,0,0))
  # found at http://zoonek2.free.fr/UNIX/48_R/15_Time_Series.txt for smoothing noisy sunspot data
  plot(DataList[cnt,], 
       type = 'p', pch=20,
       ylab = yLab, 
       xlab = paste("Time (#",CatBins$newMinPerBin,"-min Bins from ",myData[1,1],")",sep=""),
       xaxt="n",
       main = "", col="mediumslateblue")
#  filter smooths taking values before and after   (doesn't work if lib{signal} is loded!!!)
  smoothData<-filter(DataList[cnt,], rep(1/k,k))
  lines( smoothData,     #  same with method="convolution"),
         col = 'red', 
         lwd = 3)   #  ,names.arg = substr(TimeBins[],12,16) ,axis.lty = 1

  #text(0,0, labels = "Dark Onset-->                                                           ", srt = 90, pos = 1, cex=.5,xpd = TRUE)

  dayLines = seq(0,length(DataList[cnt,]),CatBins$binsPerDay)
  axis(1,at=dayLines,las=2, cex = .2)
  abline(v=dayLines,col="gray")
  endList<-length(DataList[cnt,])
  
    if (Avg)  {    
        title(paste('Smoothing (k=',k,')\nFile',fileNum,', Avg across',CatBins$animals,'data columns:  ',nameVector[startX],' - ',nameVector[endX],'\n',myData[1,1],'   to   ',myData[CatBins$endData,1]),cex.main=.9,col="blue")    #,xlab = paste("Bin count:   ",CatBins$binsPerDay,'bins per day'))
        fileoutSmoothX <- sub(pattern=".", replacement="-Avg.", x=fileoutSmooth, fixed = TRUE)
    } else {
        title(paste('Smoothing (k=',k,')\nFile',fileNum,', Column ',cnt,': ',nameVector[cnt+3],'\n',myData[1,1],'   to   ',myData[CatBins$endData,1]),cex.main=.9,col="blue")     #,xlab = paste("Bin count:   ",CatBins$binsPerDay,'bins per day'))
        fileoutSmoothX <- sub(pattern=".", replacement=paste("-col",cnt,".",sep=""), x=fileoutSmooth,fixed = TRUE)
    }  # add file name, change 5 to variable    tail(myData[,1],n=1))
if (Rverbose!=-1){
  title(sub=paste(sizePts,'mins/point;   ',binPts,'points/bin;   ',CatBins$newMinPerBin,'mins/bin;     ',CatBins$binsPerDay,'bins/day'),cex.sub=.7,col="blue")       #  ";     \nBin count: ",CatBins$binsPerDay,'bins per day'),
}
  #mtext(paste("Dark Onset at bin",startData,"                  ",fileName,"   ",thisTime),side=1,line = 5, cex =.5, adj=.8)
  mtext(paste("Dark Onset at bin",startData),side=1,line = 5, cex =.5, adj=.01)    # use index as bin#
  mtext(paste(fileName,"   ",thisTime),side=1,line = 5, cex =.5, adj=.8) 
  if (export==T){
    #print(fileoutSmoothX)
    write.matrix(cbind(TimeBins,smoothData), file = fileoutSmoothX, sep = "\t")
    #filter(DataList[cnt,], rep(1/k,k))
  }
  }  # end for (cnt in 1:CatBins$plotCnt)

  #remove read only list components 
  op$cin<-NULL
  op$cra<-NULL
  op$csi<-NULL
  op$cxy<-NULL
  op$din<-NULL
  op$page<-NULL
  par(op)
end
}
